'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createSource = createSource;

var _graphqlTools = require('graphql-tools');

var _immutable = require('immutable');

var _createSource2 = require('redux-source/lib/createSource');

var _createSource3 = _interopRequireDefault(_createSource2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function createSource(_ref) {
  var typeDefs = _ref.schema,
      resolvers = _ref.resolvers;

  var executableSchema = (0, _graphqlTools.makeExecutableSchema)({
    typeDefs: typeDefs,
    resolvers: resolvers
  });
  return (0, _createSource3.default)({
    executableSchema: executableSchema,
    createInitialState: function createInitialState(_ref2) {
      var stateName = _ref2.stateName;
      return (0, _immutable.fromJS)(_defineProperty({}, stateName, {
        data: {},
        isPending: false,
        pendingCount: 0,
        errors: []
      }));
    },
    pendingReducer: function pendingReducer(_ref3) {
      var stateName = _ref3.stateName;
      return function (state) {
        return state.mergeIn([stateName], (0, _immutable.Map)({
          isPending: true,
          pendingCount: state.getIn([stateName, 'pendingCount']) + 1,
          errors: (0, _immutable.List)()
        }));
      };
    },
    successReducer: function successReducer(_ref4) {
      var stateName = _ref4.stateName;
      return function (state, _ref5) {
        var payload = _ref5.payload;
        return state.withMutations(function (_state) {
          var count = _state.getIn([stateName, 'pendingCount']) - 1;
          var data = _state.getIn([stateName, 'data']);
          _state.mergeIn([stateName], (0, _immutable.Map)({
            isPending: count > 0,
            pendingCount: count,
            errors: (0, _immutable.List)()
          }));
          if (payload) {
            if (!data) {
              _state.setIn([stateName, 'data'], (0, _immutable.fromJS)(payload));
            } else {
              _state.mergeIn([stateName, 'data'], (0, _immutable.fromJS)(payload));
            }
          } else {
            _state.setIn([stateName, 'data'], null);
          }
        });
      };
    },
    errorReducer: function errorReducer(_ref6) {
      var stateName = _ref6.stateName;
      return function (state, _ref7) {
        var payload = _ref7.payload;

        var count = state.getIn([stateName, 'pendingCount']) - 1;
        return state.mergeIn([stateName], (0, _immutable.Map)({
          isPending: count > 0,
          pendingCount: count,
          errors: (0, _immutable.fromJS)(payload)
        }));
      };
    }
  });
}
//# sourceMappingURL=index.js.map